using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace RakeTendril
{
    public partial class DisplayForm : Form
    {
        private MainForm mainForm;

        public DisplayForm(MainForm mainForm, string name)
        {
            this.mainForm = mainForm;
            InitializeComponent();
            Text = name;
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);

            BackColor = Color.FromArgb((int)Tendril.Param.BackR, (int)Tendril.Param.BackG, (int)Tendril.Param.BackB);

            float scaleH = 1.0f;
            float scaleW = 1.0f;
            if (ClientSize.Width != 0 && ClientSize.Height != 0)
            {
                scaleH = MainForm.bitmapHeight * ClientSize.Width / (float)(MainForm.bitmapWidth * ClientSize.Height); // OK if tall enough
                scaleW = 1.0f;
                if (MainForm.bitmapWidth * ClientSize.Height < MainForm.bitmapHeight * ClientSize.Width) // window wider
                {
                    scaleW = 1.0f / scaleH;
                    scaleH = 1.0f;
                }
            }
            lock(mainForm.bitmap)
            {
                e.Graphics.DrawImage(mainForm.bitmap,
                    new Rectangle((int)(ClientSize.Width*0.5f*(1.0f-scaleW)), (int)(ClientSize.Height*0.5f*(1.0f-scaleH)),
                    (int)(ClientSize.Width*scaleW), (int)(ClientSize.Height*scaleH)),
                    new Rectangle(0, 0, MainForm.bitmapWidth, MainForm.bitmapHeight),
                    GraphicsUnit.Pixel);
            }
        }
    }
}